<template>
  <div id="welcome-pilot" class="overflow-x-hidden">
    <div id="overlay" />
    <vx-card class="main-card">
      <img
        src="~@/assets/images/logo/skyriff-logo.png"
        alt="skyriff logo"
        style="width:130px;"
        class="mx-auto mb-6"
      />
      <introduction v-if="step === 1" @nextStep="goNextStep"></introduction>
      <poll v-else-if="step === 2" @nextStep="goNextStep"></poll>
      <registration v-else-if="step === 3" @nextStep="goNextStep"></registration>
      <sorry v-else-if="step === -1"></sorry>
    </vx-card>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import api from "@/api/auth.api.ts";
import Cookies from "js-cookie";
import { screenSizeMixin } from "@/mixins";
import Introduction from "@/components/pages/welcome-pilot/introduction.vue";
import Poll from "@/components/pages/welcome-pilot/poll.vue";
import Registration from "@/components/pages/welcome-pilot/registration.vue";
import Sorry from "@/components/pages/welcome-pilot/sorry.vue";
import { FIRST_VISIT } from "@/helpers/constants";

export default Vue.extend({
  mixins: [screenSizeMixin],
  components: { Introduction, Poll, Registration, Sorry },
  data() {
    return {
      step: 1,
      pollForm: {
        punctual: null,
        angry: null,
        responsible: null
      },
      registrationForm: {
        email: "",
        password: "",
        confimPassword: ""
      }
    };
  },
  methods: {
    async register() {
      await api
        .register(
          this.registrationForm.email,
          this.registrationForm.password,
          this.pollForm.punctual,
          this.pollForm.angry,
          this.pollForm.responsible
        )
        .then(response => {
          if (response.status === 200) {
            Cookies.set(FIRST_VISIT, true);
            this.$router.push("/profile/");
          }
        });
    },

    goNextStep(data) {
      if (this.step === 1) {
        this.nextStep();
      } else if (this.step === 2) {
        if (data.punctual > 3 && data.angry < 4 && data.responsible > 3) {
          this.pollForm = data;
          this.nextStep();
        } else {
          this.step = -1;
        }
      } else if (this.step === 3) {
        this.registrationForm = data;
        this.register();
      }
    },

    nextStep() {
      this.step++;
    }
  }
});
</script>

<style lang="scss">
#welcome-pilot {
  background-image: url("~@/assets/images/pages/island-bg-1920.jpg");
  height: 100vh;
  width: 100vw;

  #overlay {
    position: absolute;
    width: 100vw;
    height: 100vh;
    background-image: url("../../assets/images/pages/dots-overlay-yellow.png");
    background-repeat: repeat;
    opacity: 0.5;
  }

  .main-card {
    width: 50%;
    margin: auto;
    margin-top: 8%;
    max-width: 570px;
    font-size: 16px;

    @media (max-width: 576px) {
      width: 94%;
      margin-top: 15%;
    }
  }
}
</style>